{-----------------------------------------------------------------}
{ :   -     }
{    ,  }
{   -                                       }
{-----------------------------------------------------------------}
{   -                            }
{  TMainWindow.wmTimer                                   }
{-----------------------------------------------------------------}
program Analog_IO;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$R analog_i.res }
{$I analog_i.inc }

Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
   end;

   PMainWindow = ^TMainWindow;
   TMainWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      procedure   SetupWindow; virtual;
      destructor  Done; virtual;
      procedure   WmTimer(var Msg:TMessage); virtual wm_First + wm_Timer;
   end;

Var
   DACEd : PEdit;
   AdcEdArray: array [1..16] of PStatic;

{-----------------------------------------------------------------}
{ ,                    }
{-----------------------------------------------------------------}
constructor TMainWindow.Init(AParent: PWindowsObject);
Var
   j : Integer;
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  DACEd:=New(PEdit, InitResource(@Self, id_DacEd, 6));
  for j:=1 to 16 do
     AdcEdArray[j]:=New(PStatic, InitResource(@Self, id_ADCEd+(j-1),6));
end;

destructor TMainWindow.Done;
begin
   KillTimer(HWindow, id_Timer);
   inherited Done;
end;

procedure TMainWindow.SetupWindow;
begin
   inherited SetupWindow;
   SetTimer(HWindow, id_Timer, 200, nil);
   LOW_POWER(0);  {     N-1250.
                       }
end;

{------------------------------------------------------------------------}
{         16           }
{   Kadr                                                 }
{------------------------------------------------------------------------}
procedure TMainWindow.WmTimer;
Var
  P     : array [1..80] of char;
  S     : String;
  Error : Integer;
  rDAC  : Real;
  j     : Integer;
  Channels, Data:array [1..16] of Integer;
begin
   DACEd^.GetText(@P, SizeOf(P));
   Val(StrPas(@P), rDAC, Error);
   OUTDA(Round(rDAC*2047/5.12));

   for j:=1 to 16 do
      Channels[j]:=CREATE_CHANNEL(j-1,0,0);
   KADR(Data, Channels, 16);

   for j:=1 to 16 do
      begin
         Str(Data[j]/2047*5.12:5:3, S);
         StrPCopy(@P,S);
         AdcEdArray[j]^.SetText(@P);
      end;

end;


{-----------------------------------------------------------------}
procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PMainWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;

   DemoApplication.Init('single_i');
   DemoApplication.Run;
   DemoApplication.Done;
end.
