unit Filei;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons, StdCtrls;

type
  TMainForm = class(TForm)
    StartWriteBtn: TButton;
    StopWriteBtn: TButton;
    Label1: TLabel;
    CounterEd: TEdit;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    ChanEd: TEdit;
    NKadrEd: TEdit;
    RateEd: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    FileNameEd: TEdit;
    Label5: TLabel;
    procedure CancelBtnClick(Sender: TObject);
    procedure StartWriteBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StopWriteBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AppIdle(Sender: TObject; var Done: Boolean);
  end;

var
  MainForm: TMainForm;

implementation
Uses
   lcard_ad;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnIdle := AppIdle;
end;


procedure TMainForm.CancelBtnClick(Sender: TObject);
begin
   Close;
end;


Var
   BlocksWritten : Integer;
   NChan, NKadr, Rate : Integer;
   Data     : pointer;
   FOut     : File;
Const
   WritingFile : Boolean = false;

procedure TMainForm.StartWriteBtnClick(Sender: TObject);
Const
   MaxChan = 31;
Var
   i        : Integer;
   Channels : array [1..MaxChan] of Word;
begin
   try
      NChan:=StrToInt(ChanEd.Text);
      NKadr:=StrToInt(NKadrEd.Text);
      Rate:=StrToInt(RateEd.Text);
      if Rate<5 then Rate:=5;
      if NChan<1 then NChan:=1;
      if NChan > MaxChan then NChan:=MaxChan;
      if NKadr<1 then NKadr:=1;
      AssignFile(FOut,FileNameEd.Text);
   except
      on EConvertError do
         begin
            Application.MessageBox(' ', '', MB_OK or MB_ICONSTOP or MB_TASKMODAL);
            exit;
         end;
   end;

   Rewrite(FOut, NKadr*NChan*2);
   getmem(Data, NKadr*NChan*2);
   {     : }
   {    1-iChan               }
   { !    0!!!            }
   for i:=1 to NChan do
      Channels[i]:=CREATE_CHANNEL(i-1,0,0);
   DMAALL(Data, NKadr*2, Channels, NChan, Rate, 1);
   BlocksWritten:=0;
   WritingFile:=true;
end;

procedure TMainForm.StopWriteBtnClick(Sender: TObject);
begin
   WritingFile:=False;
   DMA_OFF;
   freemem(Data, NKadr*NChan*2);
   CloseFile(FOut);
end;


procedure TMainForm.AppIdle(Sender: TObject; var Done: Boolean);
begin
   if WritingFile then
      begin
         GET_BUFFER_HALF(Data^);
         blockwrite(FOut, Data^, 1);
         Inc(BlocksWritten);
         CounterEd.Text:=IntToStr(BlocksWritten);
      end;
  Done := False;
end;



procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   CanClose := not WritingFile;
end;

end.
