{-----------------------------------------------------------------}
{ :       DMA                   }
{         , ..      }
{ L305, L12XX                                                     }
{-----------------------------------------------------------------}
program File_i;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$I file_i.inc }
{$R file_i.res }
Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
      function  IdleAction:Boolean; virtual;
   end;

   PMainWindow = ^TMainWindow;
   TMainWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      function    CanClose:Boolean; virtual;

      procedure   idStartWrite(var Msg:TMessage); virtual id_First + id_StartWrite;
      procedure   idStopWrite(var Msg:TMessage); virtual  id_First + id_StopWrite;
   end;

Var
   RateEd, ChanEd, NKadrEd, FileNameEd : PEdit;
   CounterSt : PStatic;
   WritingFile : Boolean;

{-----------------------------------------------------------------}
{ ,                                   }
{-----------------------------------------------------------------}
constructor TMainWindow.Init(AParent: PWindowsObject);
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  RateEd:=New(PEdit, InitResource(@Self,  id_RateEd, 6));
  ChanEd:=New(PEdit, InitResource(@Self,  id_ChanEd, 6));
  NKadrEd:=New(PEdit, InitResource(@Self, id_NKadrEd,6));
  FileNameEd:=New(PEdit, InitResource(@Self, id_FileNameEd,80));
  CounterSt:=New(PStatic, InitResource(@Self, id_CounterSt,6));

  WritingFile:=False;
  LOW_POWER(0);  {     N-1250.
                       }

end;

function TMainWindow.CanClose;
begin
   Canclose:=not WritingFile;
end;

{ --------------------------------------------------------------------- }
{      START                         }
{ --------------------------------------------------------------------- }
Const
   MaxChan = 32;

Var
   iChan, iRate,
   iNKadr        : Word;
   Data          : pointer;
   FOut          : file;
   BlocksWritten : Integer;

procedure TMainWindow.idStartWrite(var Msg:TMessage);
Var
  Channels     : array [1..MaxChan] of Integer;
  Error        : Integer;
  S            : array [1..80] of Char;
  i            : Integer;
begin
   ChanEd^.GetText(@S, SizeOf(S));
   Val(StrPas(@S), iChan, Error);

   RateEd^.GetText(@S, SizeOf(S));
   Val(StrPas(@S), iRate, Error);

   NKadrEd^.GetText(@S, SizeOf(S));
   Val(StrPas(@S), iNKadr, Error);

   FileNameEd^.GetText(@S, SizeOf(S));

   Assign(FOut,S);
   rewrite(FOut, iNKadr*iChan*2);

   if iRate < 5 then iRate:=5;
   if iChan < 1 then iChan:=1;
   if iChan > MaxChan then iChan:=MaxChan;
   if iNKadr< 0 then iNKadr:=1;
   getmem(Data, iNKadr*iChan*2);
   {     : }
   {    1-iChan               }
   { !    0!!!            }
   for i:=1 to iChan do
      Channels[i]:=CREATE_CHANNEL(i-1,0,0);
   DMAALL(Data, iNKadr*2, Channels, iChan, iRate, 1);
   WritingFile:=True;
   BlocksWritten:=0;
end;


procedure TMainWindow.idStopWrite(var Msg:TMessage);
begin
   WritingFile:=False;
   DMA_OFF;
   freemem(Data, iNKadr*iChan*2);
   close(FOut);
end;



{-----------------------------------------------------------------}
function TDemoApplication.IdleAction:Boolean;
Var
   S: String;
   P: Array [1..32] of Char;
begin
   if WritingFile then
      begin
         GET_BUFFER_HALF(Data^);
         blockwrite(FOut, Data^, 1);
         Inc(BlocksWritten);

         Str(BlocksWritten, S);
         StrPCopy(@P,S);
         CounterSt^.SetText(@P);
      end;
   IdleAction:=True;
end;

procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PMainWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;
   DemoApplication.Init('single_i');
   DemoApplication.Run;
   DemoApplication.Done;
end.
