{-----------------------------------------------------------------}
{ :      (SOFT)      }
{  DMA          }
{-----------------------------------------------------------------}
{                       }
{  TGraphStatic.wmPaint                                  }
{-----------------------------------------------------------------}
program Multi_I;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$R multi_i.res }
{$I multi_i.inc }
Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
   end;

   PGraphWindow = ^TGraphWindow;
   TGraphWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      procedure   SetupWindow; virtual;
      destructor  Done; virtual;
      procedure   WmTimer(var Msg:TMessage); virtual wm_First + wm_Timer;
   end;

   PGraphStatic = ^TGraphStatic;
   TGraphStatic = object(TStatic)
      procedure wmPaint(var Msg:TMessage) ; virtual wm_First+wm_Paint;
      procedure Update;
   end;

Var
   ChanEd, RateEd : PEdit;
   GraphStatic : PGraphStatic;
   ModeCB      : PCheckBox;
{-----------------------------------------------------------------}
{    ' TStatic    wmPaint }
{-----------------------------------------------------------------}
Const
   NPoint=200;  {          }
   MaxChan=32;  {     }

procedure TGraphStatic.wmPaint(var Msg:TMessage);
Type
  PData = ^TData;
  TData = array [0..32766] of Integer;
var
  DC         : HDC;
  PS         : TPaintStruct;
  Pen, OldPen: HPen;
  Brush, OldBrush : HBrush;
  i,j        : Integer;
  Data       : PData;
  Channels   : array [1..MaxChan] of Integer;
  Max        : Real;

  sChan, sRate     : array [1..80] of Char;
  Error, iChan, iRate: Integer;
begin
   DC:=BeginPaint(HWindow, PS);
   Pen:=CreatePen(PS_Solid, 1, RGB(255,255,0));
   OldPen:=SelectObject(DC,Pen);

   Brush:=CreateSolidBrush(RGB(0,0,127));
   OldBrush:=SelectObject(DC, Brush);

   ChanEd^.GetText(@sChan, SizeOf(sChan));
   RateEd^.GetText(@sRate, SizeOf(sRate));
   Val(StrPas(@sChan), iChan, Error);
   Val(StrPas(@sRate), iRate, Error);
   if iRate<5 then iRate:=5;
   if iChan<1 then iChan:=1;

   {     : }
   {    1-iChan               }
   { !    0!!!            }
   for i:=1 to iChan do
      Channels[i]:=CREATE_CHANNEL(i-1,0,0);

   {      }
   getmem(Data, NPoint*iChan*2);
   if Data=nil then
      begin
      MessageBox(0,' ','', MB_OK or MB_TASKMODAL);
      exit;
      end;

   {      }
   if ModeCB^.GetCheck=BF_CHECKED then
      begin
         {    DMA}
         DMAALL(Data^, NPoint, Channels,iChan,iRate,0);
         while DMA_TEST=0 do ;
         DMA_OFF;
      end
   else
      {     }
      SOFT(Data^, NPoint, Channels, iChan, iRate);


   Max:=1;
   for i:=0 to iChan-1 do
      for j:=0 to NPoint-1 do
         if Abs(Data^[j*iChan+i])>Max then
            Max:=Abs(Data^[j*iChan+i]);
   Max:=Max*1.2;

   Rectangle(DC, 0,0, GraphStatic^.Attr.W, GraphStatic^.Attr.H);
   MoveTo(DC, 0, GraphStatic^.Attr.H div 2);
   LineTo(DC, GraphStatic^.Attr.W-1, GraphStatic^.Attr.H div 2);

   SelectObject(DC, OldPen);
   DeleteObject(Pen);

   {   }
   for i:=0 to iChan-1 do
      begin
         Pen:=CreatePen(PS_Solid, 1, RGB(255*((i+6) and 4), 255*((i+6) and 2), 255*((i+6) and 1)));
         OldPen:=SelectObject(DC,Pen);
         MoveTo(DC, 0, Round(-(Data^[i]/Max*GraphStatic^.Attr.H/2) + GraphStatic^.Attr.H/2));
         for j:=1 to NPoint-1 do
            LineTo(DC, Round(j/NPoint*GraphStatic^.Attr.W),
               Round(-(Data^[j*iChan+i]/Max*GraphStatic^.Attr.H/2) + GraphStatic^.Attr.H/2));
         SelectObject(DC, OldPen);
         DeleteObject(Pen);
      end;

   {    }
   freemem(Data, NPoint*iChan*2);

   SelectObject(DC, OldBrush);
   DeleteObject(Brush);
   EndPaint(HWindow, PS);
end;

{       }
procedure TGraphStatic.Update;
begin
   InvalidateRect(HWindow, nil, False);
end;


{-----------------------------------------------------------------}
{ ,                            }
{                                    }
{-----------------------------------------------------------------}
constructor TGraphWindow.Init(AParent: PWindowsObject);
Var
   tmp : PWindow;
   dX, dY : Integer;
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  RateEd:=New(PEdit, InitResource(@Self, id_RateEd, 4));
  ChanEd:=New(PEdit, InitResource(@Self, id_ChanEd, 4));
  GraphStatic:=New(PGraphStatic, InitResource(@Self, id_GraphStatic,1));
  ModeCB:=New(PCheckBox, InitResource(@Self, id_ModeCB));
end;


destructor TGraphWindow.Done;
begin
   KillTimer(HWindow, id_Timer);
   inherited Done;
end;

procedure TGraphWindow.SetupWindow;
begin
   inherited SetupWindow;
   SetTimer(HWindow, id_Timer, 500, nil);
   LOW_POWER(0);  {     N-1250.
                       }
end;

procedure TGraphWindow.WmTimer;
begin
   GraphStatic^.Update;
end;

{-----------------------------------------------------------------}
procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PGraphWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;

   DemoApplication.Init('multi_i');
   DemoApplication.Run;
   DemoApplication.Done;
end.
