{-----------------------------------------------------------------}
{ :                      }
{-----------------------------------------------------------------}
{                        }
{  TGraphStatic.wmPaint                                  }
{-----------------------------------------------------------------}
program Single_I;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$I single_i.inc }
{$R single_i.res }
Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
   end;

   PGraphWindow = ^TGraphWindow;
   TGraphWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      procedure   SetupWindow; virtual;
      destructor  Done; virtual;
      procedure   WmTimer(var Msg:TMessage); virtual wm_First + wm_Timer;
   end;

   PGraphStatic = ^TGraphStatic;
   TGraphStatic = object(TStatic)
      procedure wmPaint(var Msg:TMessage) ; virtual wm_First+wm_Paint;
      procedure Update;
   end;

Var
   ChanEd, RateEd : PEdit;
   GraphStatic : PGraphStatic;
   ModeCB      : PCheckBox;

{-----------------------------------------------------------------}
{    ' TStatic    wmPaint }
{-----------------------------------------------------------------}
Const NPoint=200;  {     }
procedure TGraphStatic.wmPaint(var Msg:TMessage);
var
  DC         : HDC;
  PS         : TPaintStruct;
  Pen, OldPen: HPen;
  Brush, OldBrush : HBrush;
  j          : Integer;
  Data          : array [1..NPoint] of Integer;
  Max        : Real;

  sChan, sRate     : array [1..80] of Char;
  Error, iChan, iRate: Integer;
begin
   DC:=BeginPaint(HWindow, PS);
   Pen:=CreatePen(PS_Solid, 1, RGB(255,255,0));
   OldPen:=SelectObject(DC,Pen);

   Brush:=CreateSolidBrush(RGB(0,0,127));
   OldBrush:=SelectObject(DC, Brush);

   ChanEd^.GetText(@sChan, SizeOf(sChan));
   RateEd^.GetText(@sRate, SizeOf(sRate));
   Val(StrPas(@sChan), iChan, Error);
   Val(StrPas(@sRate), iRate, Error);
   if iRate<5 then iRate:=5;

   {      }
   if ModeCB^.GetCheck=BF_CHECKED then
      begin
         {    DMA }
         DMAONE(Data, NPoint, CREATE_CHANNEL(iChan,0,0),iRate,0);
         while DMA_TEST=0 do ;
         DMA_OFF;
      end
   else
      STREAM(Data, NPoint, CREATE_CHANNEL(iChan,0,0), iRate);

   Max:=1;
   for j:=1 to NPoint do
      if Abs(Data[j])>Max then Max:=Abs(Data[j]);
   Max:=Max*1.2;

   Rectangle(DC, 0,0, GraphStatic^.Attr.W, GraphStatic^.Attr.H);
   MoveTo(DC, 0, GraphStatic^.Attr.H div 2);
   LineTo(DC, GraphStatic^.Attr.W-1, GraphStatic^.Attr.H div 2);

   MoveTo(DC, 0, Round(-(Data[1]/Max*GraphStatic^.Attr.H/2) + GraphStatic^.Attr.H/2));
   for j:=2 to NPoint do
   LineTo(DC, Round((j-1)/NPoint*GraphStatic^.Attr.W), Round(-(Data[j]/Max*GraphStatic^.Attr.H/2) + GraphStatic^.Attr.H/2));

   SelectObject(DC, OldPen);
   SelectObject(DC, OldBrush);
   DeleteObject(Brush);
   DeleteObject(Pen);
   EndPaint(HWindow, PS);
end;


{       }
procedure TGraphStatic.Update;
begin
   InvalidateRect(HWindow, nil, False);
end;

{-----------------------------------------------------------------}
{ ,                            }
{                                    }
{-----------------------------------------------------------------}
constructor TGraphWindow.Init(AParent: PWindowsObject);
Var
   tmp : PWindow;
   dX, dY : Integer;
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  RateEd:=New(PEdit, InitResource(@Self, id_RateEd, 6));
  ChanEd:=New(PEdit, InitResource(@Self, id_ChanEd, 6));
  GraphStatic:=New(PGraphStatic, InitResource(@Self, id_GraphStatic,1));
  ModeCB:=New(PCheckBox, InitResource(@Self, id_ModeCB));
end;


destructor TGraphWindow.Done;
begin
   KillTimer(HWindow, id_Timer);
   inherited Done;
end;

procedure TGraphWindow.SetupWindow;
begin
   inherited SetupWindow;
   SetTimer(HWindow, id_Timer, 500, nil);
   LOW_POWER(0);  {     N-1250.
                       }
end;

procedure TGraphWindow.WmTimer;
begin
   GraphStatic^.Update;
end;

{-----------------------------------------------------------------}
procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PGraphWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;

   DemoApplication.Init('single_i');
   DemoApplication.Run;
   DemoApplication.Done;
end.
